module(..., package.seeall)
local T1 = os.clock()
local conf = require'nsgconf'
local utf8 = require"utf8"
--local ox = require'posix'

local urlDecode
local htmlEncode
local doCmd
local mainPage
local loginPage
local genOut
local genError
local genFast
local usec
local tag
local bodyPrint
local stdHead
local fstr
local calcValue
local initPostData
local initEnvData
local headPrint
local htmlDecode
local checkPasswd
local selectLanguage
local explodeToTable
local tokens
local readpopen

function readpopen(prog)
  local f = io.popen(prog)
  local s
  if f then
    s = f:read("*a")
    f:close()
  end
  return s
end

local old_checkPasswd = function(login, pass)
                 require"posix"
                 local f
                 f = io.open("/etc/shadow", "r")
                 if not f then
                    return false
                 end
                 local hash
                 hash = f:read("*a")
                 if not hash then
                    return false
                 end
                 f:close()
                 --print(hash)
                 hash = string.match(hash, "[^%W]*"..login..":([^:]*):")
                 --print(hash)
                 if not hash then
                    return false
                 elseif hash=="" then
                    return true
                 else
                    local res
                    local res2
                    res,res2 = pcall(posix.crypt,pass,hash)
                    if res and res2==hash then
                       return true
                    else
                       return false
                    end
                 end
                 return false
              end


checkPasswd = function(login, pass)
  require'nsg'
  local res = nsg.pamAuth('login', login, pass)
  if not res then
    return old_checkPasswd(login, pass)
  else
    return res
  end
end

stdHead = function (http)
             --http:headPrint("HTTP/1.0 200 OK")
             headPrint(http, "Status", "200")
             http:headPrint("Content-Type", "text/html")
             http:headPrint("Cache-Control", "no-store, no-cache, must-revalidate")
             http:headPrint("Cache-Control", "post-check=0, pre-check=0")
          end

fstr = function (...)
          return table.concat({...})
       end

calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or '' 
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
                  local res, value, v1 = pcall(loadstring('setfenv(1, {})return '..valString))
                  if not res or value == nil or v1 then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
            end

initPostData = function (http)
                  if nsgServer == "xavante" then
                     http.data = cgilua.POST
                  else
                     if( http.env.request_method == 'POST' and
                         -- string.match(http.env.content_type,'application\/x-www-form-urlencoded') and
                         tonumber(http.env.content_length) > 0 )
                     then
                        local x=0
                        -- !!!  Don`t read more then http.env.content_length
                        for line in io.lines() do
                           http.raw_post = http.raw_post .."\010".. line;
                           for s1,s2 in string.gmatch('&'..line..'&', '([^&=]*)%=([^&=]*)') do
                              http.data[urlDecode(s1)] = urlDecode(s2)
                           end
                           x = x + string.len(line)+1
                           if x >  tonumber(http.env.content_length) then
                              break
                           end
                        end
                     end

                     -- override POST data through url string
                     local x1,x2,params = string.find(http.env.request_uri or '', '?(.*)$')
                     for s1,s2 in string.gmatch((params or "") ..'&', '([^&=]*)%=([^&=]*)') do
                        http.data[s1] = s2
                     end
                  end
               end

tokens = function (s, delim)
   local pos = 1
   return function()
             local f, l = string.find(s, '[^'..delim..']+', pos)
             if f then
                pos = l + 1
                return string.sub(s, f, l)
             else
                return nil
             end
          end
end

explodeToTable = function (path, delim)
   local pathTable = {}
   for s in tokens(path, delim) do
      table.insert(pathTable, s)
   end
   return pathTable
end

selectLanguage = function (http_lang)
   local langTokens = explodeToTable(http_lang or "ru", ",")
   local lang = {};
   local maxLang = "ru"
   local maxQ = 0
   local l,q
   for k,v in ipairs(langTokens) do

      l, q = string.match( string.gsub(v, "%s", "") , "([a-zA-Z][a-zA-Z])([;]*)([q=]*)([0-9.]*)")

      if((q == nil) or (q=="")) then
         q =  1000
      else
         q = string.match(q, ";q=([0-9.]*)" )
         if((q == nil) or (q=="")) then
            q =  1000
         else
            q = tonumber(q)
         end
      end
      l = l or "en"
      --print("//".. l .."~".. tostring(q))
      if(type(lang[l]) == "number") then
         lang[l] = ((tonumber(q) > lang[l]) and q) or lang[l]
      else
         lang[l] = tonumber(q)
      end

      if maxQ < lang[l] then
         maxQ = lang[l]
         maxLang = l
      end
   end
   return maxLang
end


initEnvData = function (http)
                 if (nsgServer == "xavante") then
                    http.env['lang'] = selectLanguage(cgilua.servervariable("HTTP_ACCEPT_LANGUAGE"))
                    http.env['auth_type'] =     cgilua.servervariable("AUTH_TYPE")
                    http.env['gateway_interface'] = cgilua.servervariable("GATEWAY_INTERFACE")
                    http.env['path'] =          cgilua.servervariable("PATH")
                    http.env['path_info'] =     cgilua.servervariable("PATH_INFO")
                    http.env['pwd'] =           cgilua.servervariable("PWD")
                    http.env['query_string'] =  cgilua.servervariable("QUERY_STRING")
                    http.env['remote_addr'] =   cgilua.servervariable("REMOTE_ADDR")
                    http.env['remote_port'] =   cgilua.servervariable("REMOTE_PORT")
                    http.env['remote_user'] =   cgilua.servervariable("REMOTE_USER")
                    http.env['request_method'] = cgilua.servervariable("REQUEST_METHOD")
                    http.env ['request_uri'] =   cgilua.servervariable("REQUEST_URI")
                    http.env['script_filename'] =cgilua.servervariable("SCRIPT_FILENAME")
                    http.env['script_name'] =   cgilua.servervariable("SCRIPT_NAME")
                    http.env['server_port'] =   cgilua.servervariable("SERVER_PORT")
                    http.env['server_protocol'] = cgilua.servervariable("SERVER_PROTOCOL")
                    http.env['server_software'] = cgilua.servervariable("SERVER_SOFTWARE")
                    http.env['content_type'] =  cgilua.servervariable("CONTENT_TYPE")
                    http.env['content_length'] =cgilua.servervariable("CONTENT_LENGTH")
                 else
                    http.env['lang'] = selectLanguage(os.getenv("HTTP_ACCEPT_LANGUAGE"))
                    http.env['auth_type'] =     os.getenv("AUTH_TYPE")
                    http.env['gateway_interface'] = os.getenv("GATEWAY_INTERFACE")
                    http.env['path'] =          os.getenv("PATH")
                    http.env['path_info'] =     os.getenv("PATH_INFO")
                    http.env['pwd'] =           os.getenv("PWD")
                    http.env['query_string'] =  os.getenv("QUERY_STRING")
                    http.env['remote_addr'] =   os.getenv("REMOTE_ADDR")
                    http.env['remote_port'] =   os.getenv("REMOTE_PORT")
                    http.env['remote_user'] =   os.getenv("REMOTE_USER")
                    http.env['request_method'] = os.getenv("REQUEST_METHOD")
                    http.env ['request_uri'] =   os.getenv("REQUEST_URI")
                    http.env['script_filename'] = os.getenv("SCRIPT_FILENAME")
                    http.env['script_name'] =   os.getenv("SCRIPT_NAME")
                    http.env['server_port'] =   os.getenv("SERVER_PORT")
                    http.env['server_protocol'] = os.getenv("SERVER_PROTOCOL")
                    http.env['server_software'] = os.getenv("SERVER_SOFTWARE")
                    http.env['content_type'] =  os.getenv("CONTENT_TYPE")
                    http.env['content_length'] = os.getenv("CONTENT_LENGTH")
                 end
              end

urlDecode = function(s)
               return (string.gsub (string.gsub (tostring(s or ""), "+", " "),
                                    "%%(%x%x)",
                                    function (str)
                                       return string.char (tonumber (str, 16))
                                    end )
                    )
            end

htmlEncode = function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                              "\"",
                                                              "&quot;"),
                                                 "<",
                                                 "&lt;"),
                                    ">",
                                    "&gt;")
             end


htmlDecode = function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s), "&qt;", ">"),
                                                              "&quot;",
                                                              "\""),
                                                 "&lt;",
                                                 "<"),
                                    "&amp;",
                                    "&")
             end



headPrint = function(http, param, value)
               if param ~= nil then
                  http.head[param] = value
               end
            end


bodyPrint = function(http, text, ...)
               if text ~= nil then
                  http.body.text = http.body.text..tostring(text)
                  http:bodyPrint(...)
               end
            end


tag = function (shift, tag, param, inner, ret_inner)
         if(tag > "") then
            white=""
            end_white=""

            if(type(ret_inner) == 'nil') then
               ret_inner= "\n"
            else
               if(ret_inner ~= "" ) then
               end
            end

            --inner=table.concat(inner)
            while (shift > 0 ) do
               shift=shift - 1
               white = white.."  "
            end
            end_white=white

            if(ret_inner == "" ) then
               end_white=""
            end

            if(inner ~= "") then
               inner = ret_inner..inner
            else
               inner = ""
            end

            return white.."<"..tag.." "..param..">"
               ..inner..ret_inner..end_white.."</"..tag..">"
         else
            return inner
         end
      end

genOut = function(http)
            if #http.body.text==0 then http.body.text = "\0" end
            if nsgServer == "xavante" then
               cgilua.header("Cache-Control","no-store, no-cache, must-revalidate");
              -- cgilua.header("Cache-Control", "post-check=0, pre-check=0");
               for k,v in pairs(http.head) do
                  cgilua.header(k, v)
               end
               cgilua.put(http.body.text);
            else
               io.write("HTTP/1.0  "..tostring(http.head["Status"] or 200).." OK".."\013\010")
               http:headPrint("Cache-Control", "no-store, no-cache, must-revalidate")

               for k,v in pairs(http.head) do
                  if k ~= "Status" then
                     io.write(k,":",v,"\013\010");
                  end
               end
               io.write("\013\010");
               io.write(http.body.text)
            end
         end

genError = function(http, status, ...)
              http.head = {}
             -- headPrint(http, "HTTP/1.0 "..tostring(status).." OK")
              headPrint(http, "Status", tostring(status))

              http.body.text = ""
              http:bodyPrint("<html>")
              http:bodyPrint(...)
              http:bodyPrint("<pre>Env data:\010")
              for k,v in pairs(http.env) do
                 http:bodyPrint(k.."="..v.."\010")
              end
              http:bodyPrint("</pre>")
              http:bodyPrint("<pre>POST data:\010")
              for k,v in pairs(http.data) do
                 http:bodyPrint(k.."="..v.."\010")
              end
              http:bodyPrint("</pre>")
              http:bodyPrint("<pre>Raw post data:\010"..http.raw_post.."</pre>")
              http:bodyPrint("</html>")
              genOut(http)
           end

genFast = function(http, status, ...)
             http.head = {}
             --http.head.print("HTTP/1.0 "..tostring(status).." OK")
             headPrint(http, "Status", tostring(status))

             http.body.text = ""
             http.body.print(...)
             http.genOut()
          end

usec = function ()
          local f=io.popen ("cat /proc/uptime | grep -o '^[0-9]*[.][0-9]*'")
          if f then
             t=f:read("*n")
             f:close()
             return t
          else
             return 0
          end
       end

loginPage = function (http, status)
               local devName = function()
                                  local dev = {}
                                  dev[#dev + 1] = htmlEncode(readpopen("cat /proc/nsg/env | grep nsg_device | grep -oe '[^=]*$'"))
                                  dev[#dev + 1] = htmlEncode(readpopen("hostname -f"))
                                  return table.concat(dev, "<br/>")
                               end
               local err
               local ret = ""
               http:bodyPrint(
                  [[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
                           <html>
                           <head>
                           <title>NSG Web Configuration Manager</title>
                           <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
                           <link rel="stylesheet" type="text/css" href="/style.css">
                           <link rel="icon" type="image/x-icon" href="/nsg.ico">
                           <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico">
                           </head>
                           <body class="login">
                     ]]..
                     --(http.env['remote_addr'] or "")..
                     (status or "")..
                     [[
                                 <div class="login">
                                 <center>
                           <form id="loginform" class="login" onsubmit=" var loginform=document.getElementById('loginform'); if(loginform) loginform.onsubmit = function(){return false; };" method="post" enctype="application/x-www-form-urlencoded">
                                 <table class="login">
                                 <tbody>

                                 <tr height="40%">
                                 <td class="bottomcenter">
                                 <img src="/nsg_logo.png"><br/>]]..
                      devName()..
                      [[</td>
                                 </tr>
                                 <tr height="35"><td class="lcenter">Name:<input type="text" name="login" /><font color="#6699cc" >:emaN</font></td></tr>
                                 <tr height="35"><td class="lcenter">Password:<input type="password" name="pass" /><font color="#6699cc" >:drowssaP</font></td></tr>
                                 <tr><td class="topcenter"><input type="submit" name="submit" value="Login" /> 
                                 <input type="hidden" name="command" value="start" />
                                 <input type="hidden" name="timeout" value="60" />
                              </td></tr>
                                 </tbody>
                                 </table>
                                 </form>
                                 </center>
                                 </div>
                                 </body>
                                 </html>
                           ]])
            end


doCmd =
   function(cmd, htmlEnv)
      local fixCRLF =
         function (s)
            return s~=nil and  tostring(s):gsub("\n( *)(\t?)", function(s,t)
                                                                  return'\n'..(t~=''and('\t'):rep(#s+1)or'')
                                                               end or ""
                                             )
         end

      local splitString =
         function (s)
            s = s or ""
            local out = {}
            local i = 70
            local i2 = 0
            local len = utf8.len(s) or 0
            while i2<len do
               out[#out+1] = utf8.sub(s,i2 + 1, i2 + i)
               i2 = i2 + i
            end
            return out
         end

      local escapeForScript =
         function (s)
            s = splitString(s)
            for k,v in ipairs(s) do
               s[k] = '"'..((((((tostring(v or "" )):gsub("\\","\\\\")):gsub("\r","\\r")):gsub("\n","\\n")):gsub('"','\\"')):gsub("'","\\'") or "")..'"'
            end
            return table.concat(s,"+")
         end

      local script =
         function (s)
            return "<span class=\"hiddenscript\"><textarea class=\"hiddentext\">X"..htmlEncode(s or "").."X</textarea></span>"
         end
      local hideCTRL =
         function (s)
            return ("%q"):format(s):gsub("\\\n","\\n");
         end
      local text =
         function (s)
            return "<span class=\"hiddentext\"><textarea class=\"hiddentext\">X"..htmlEncode(hideCTRL(s or "")).."X</textarea></span>"
         end

      local alertScript =
         function (s)
            local len = utf8.len(s or "")
            local max=2500
            return s~=nil and script('alert('..escapeForScript(fixCRLF(len>max and s:sub(1,utf8.find(s,"%s",max/2) or max/2)..'...\n---- truncated ----\n...'..s:sub(utf8.find(s,"%s",-max/2) or -max/2) or s))..');') or ""
         end
      local ses
      local err
      local msg
      local ret = ""
      local noSes = {
         getHTML = true,
--         loadDictionary = true
      }

      if not noSes[cmd] then
         ses, err = conf.open({
                                 sesnum = (htmlEnv.data.sesnum or 0),
                                 user = htmlEnv.data.login,
                                 mode = htmlEnv.data.mode or "html",
                              })
         if not ses then
            if cmd == "tty" then
               return text("_C_L_O_S_E_D_")
            elseif cmd == "start" then
               return loginPage(htmlEnv,"Can't open nsgconf session("..(err or "")..")")
            else
               local _H = "webStartNewSession"
               local _H = "CantOpenSession"
               return  script('if (confirm(getHelp("CantOpenSession")+"("+'..escapeForScript(err or "")..'+ "). "+getHelp("webStartNewSession"))) window.location.replace(window.location.pathname);')
            end
         end
         htmlEnv.data.sesnum = ses.sesnum
         ses.timeout = (htmlEnv.data.timeout  or 20) -1
      end
      local cmdA
      cmdA = {
         login =
            function()
               msg = loginPage(htmlEnv)
            end,
         logOut =
            function()
               ret = ses:isConfigChanged()
               if (ret and not htmlEnv.data.force) then
                  local _H = "webCfgNotSavedContinue"
                  msg = script([[
                                     if (confirm(getHelp("webCfgNotSavedContinue"))) {
                                        logOut(true);
                                     };
                               ]])
               else
                  pcall(ses.closeSession, ses);
                  msg = script("window.location.replace(window.location.pathname);")
               end
            end,
         start =
            function()
               htmlEnv.data.pagename = nsgPageName
               htmlEnv.data.locale = ses:setLocale() or htmlEnv.env.lang or "en"
               ses:setLocale(htmlEnv.data.locale)
               htmlEnv.data.sessionMessage = (err or "")
               ret, err = ses:getConf( false, {htmlEnv={data=htmlEnv.data}})
               msg =  ret and  ret or alertScript(err)
            end,
         edit =
            function()
               ret, err = ses:getConf( (calcValue(htmlEnv.data.path) or {}), false)
               msg =  ret and  ret or alertScript(err)
            end,
         getConf =
            function()
               ret, err = ses:getConf( (calcValue(htmlEnv.data.path) or {}), {htmlEnv={data=htmlEnv.data}})
               msg =  ret and  ret or alertScript(err)
            end,
         tty =
            function()
               ret, msg = ses:tty(calcValue(htmlEnv.data.path) or {},  htmlEnv.data.value and htmlEnv.data.value or htmlEnv.data.value)
               msg = text((ret) or
                       (type(ret) == 'boolean' and (not ret) and (msg~="") and  msg) or
                    ((not ret or  msg=="") and "_C_L_O_S_E_D_") or msg)
            end,
         setValue =
            function()
               local rerr, rmsg
               if htmlEnv.data.value == nil then
                  rerr, rmsg = doCmd("removeKey", htmlEnv)
                  err, ret, msg = ses:setValue(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
                  if not rerr then
                     msg = (msg or "")..(rmsg and alertScript(rmsg) or "")
                  end
               else
                  err, ret, msg = ses:setValue(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
                  if not err then
                     msg = (msg or "")..(ret and alertScript(ret) or "")
                  end
               end
            end,
         paste =
            function()
               err, msg = ses:paste(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and (htmlDecode(htmlEnv.data.value)) or "", nil)
               msg = (not err and alertScript(msg or "Error") or "")..script("loadDir(window.execScriptsParam, true);")
            end,
         validate =
            function()
               err, msg = ses:paste(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and (htmlEnv.data.value) or "", true)
               msg = alertScript(msg or "OK")
            end,
         newKey =
            function()
               err, msg = ses:newKey(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and msg or  alertScript(msg)
            end,
         insertKey =
            function()
               err, msg = ses:insertKey(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and msg or  alertScript(msg)
            end,
         saveConf =
            function()
               err, msg = ses:saveConf(calcValue(htmlEnv.data.path) or {})
               msg = err and  alertScript(err) or alertScript(msg or "Not saved!")
            end,
         applyConf =
            function()
               err, msg = ses:applyConf(calcValue(htmlEnv.data.path) or {})
               msg =  msg and alertScript(msg) or alertScript( err and "Ok" or "Fail")
            end,
         getManual =
            function()
               msg = ses:getManual(calcValue(htmlEnv.data.path) or {}, "No manual for this entry.")
               msg =  msg and alertScript(msg)
            end,
 --[==[        loadDictionary =
            function()
               local dict = readpopen([[/usr/bin/lua -e '
                                            dict={}
                                            help = require"nsgconfhelp"
                                            for k,v in pairs(help) do
                                               if (type(v) == "table") and (k ~= "_M") then
                                                  lang = {}
                                                  for l,s in pairs(v) do
                                                     if type(s) == "string" then
                                                        lang[#lang+1] = ("%q:%q"):format(tostring(l), tostring(s))
                                                     end
                                                  end
                                                  dict[#dict+1] = ("%q"):format(tostring(k))..":{"..table.concat(lang, ",").."}"
                                               end
                                            end
                                            dict = "window.dictionary = {"..table.concat(dict,",").."};"
                                            print(dict)
                                            ']])
               msg = script(dict)
            end,
            --]==]
         setLocale =
            function()
               msg = ses:setLocale(htmlEnv.data.locale)
               msg =  msg and alertScript(msg) or ""
            end,
         getUsage =
            function()
               msg = ses:getUsage(htmlEnv.data.locale)
               msg =  msg and script("window.execScriptsParam.innerHTML="..
                                     escapeForScript(msg).." + "..
                                  escapeForScript('<img alt="refresh" tabindex=0 class="brefresh" src="/nil.png">')) or ""
            end,
         removeKey =
            function()
               err, msg = ses:removeKey(calcValue(htmlEnv.data.path) or {})
               msg = err and msg or alertScript(msg)
            end,
         executeTask =
            function()
               err, msg, ret = ses:executeTask(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and text(msg)  or  msg and alertScript(msg)
            end,
         getHTML =
            function()
               htmlEnv.data.pagename = nsgPageName
               htmlEnv.data.locale = htmlEnv.data.locale or "en"
               local script = "nsgsh -q 'system.users.check-html.{user=\""..(htmlEnv.data.login).."\",path="..(htmlEnv.data.path)..",}' | grep -oE '[[:alnum:]]+'  | sed -e 's/[^[:alnum:].-_]//g'"
               local module=readpopen(script):gsub("[^a-zA-Z_.]","")
               if module == htmlEnv.data.module then
                  err, msg =  pcall(require, htmlEnv.data.module)
                  if err then
                     err, ret, msg = pcall(msg.getHTML, htmlEnv)
                  end
               else
                  err, msg = nil, "Error: Web module incorrect:"..tostring(module).."<>"..tostring(htmlEnv.data.module)
               end
               msg = err and msg or (msg or "Error")..tostring(ret)
            end,
         error =
            function()
               msg = alertScript("Error command:"..cmd)
            end,
      }

      (cmdA[cmd or "error"] or cmdA.error)()
      if ses then
         pcall(ses.closecon, ses)
      end
      return tostring(msg)
   end


function main()
   local http = {
      ['env']  = {},

      ['head'] = {
         ['text'] = ""
      },

      ['body'] = {
         ['text'] = ""
      },

      ['data'] = {},

      ['raw_post'] = '',
      headPrint = headPrint,
      bodyPrint = bodyPrint
   }

   initEnvData(http)
   initPostData(http)
   stdHead(http)

   --   genError(http, KUU);

   if (http.data['command']
         and http.data["login"] and http.data["pass"]) then
      if checkPasswd(http.data["login"], http.data["pass"]) then
         http:bodyPrint(doCmd(http.data['command'], http))
      else
         loginPage(http, "Incorrect password or username!")
      end
   elseif (http.data["command"]=="start" and http.data["login"] and http.data["pass"]) then
      loginPage(http, "Incorrect password or username!")
   else --default
      loginPage(http)
   end
   
   genOut(http)
end

--main()

--io.write(" "..(os.clock()-T1).." " )
